searchData={"items":[{"type":"task","title":"mix dumper.gen","doc":"The Dumper uses reflection to find all your app's ecto schemas, and then provide\nroutes to browse their data.  This mix task generates the controller and components\nnecessary to do that.\n\nOnce run, follow the on-screen instructions to add dumper routes to your router.\nFrom there, you can customize all aspects of the dumper.","ref":"Mix.Tasks.Dumper.Gen.html"},{"type":"task","title":"Example - mix dumper.gen","doc":"$ mix dumper.gen","ref":"Mix.Tasks.Dumper.Gen.html#module-example"},{"type":"task","title":"Requirements - mix dumper.gen","doc":"- Ecto\n- Ability to call `use *_web, :controller`.\n  - This is included in most phoenix apps by default","ref":"Mix.Tasks.Dumper.Gen.html#module-requirements"},{"type":"function","title":"Mix.Tasks.Dumper.Gen.run/1","doc":"","ref":"Mix.Tasks.Dumper.Gen.html#run/1"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"Improvements - Changelog","doc":"* Initial release of Dumper","ref":"changelog.html#improvements"},{"type":"extras","title":"Dumper","doc":"# Dumper\n\n_Takes your data and dumps it to the screen!_\n\nDumper uses reflection to find all your app's ecto schemas and provide routes\nto browse their data.  This library provides a mix task to generate the\ncontroller and components necessary to do that.\n\n![dumper](assets/dumper.gif)","ref":"readme.html"},{"type":"extras","title":"Requirements - Dumper","doc":"Dumper only works with Phoenix 1.7+ applications that use Ecto.\n\nBy default, Dumper also displays module docs for each schema.  To do this, your project must include [Earmark](https://hexdocs.pm/earmark/Earmark.html) as a dependency.","ref":"readme.html#requirements"},{"type":"extras","title":"About - Dumper","doc":"Dumper aims to make it as easy as possible for everyone on a project to access and understand its data.\n\n- All ids can be linked, so it's an incredibly fast way to explore a data model against real data.\n- Because it's implemented with reflection, it automatically covers every schema module in your project.\n- Styling is kept to a minimum so that data is front and center.\n- All associations are also shown for a given record, all on the same page.\n- Non-intrusive. No changes necessary to existing modules/files.\n- Read-only.  No accidentally deleting or editing data while browsing.\n- Shareable URLs. Having a shareable link to every record in your database is very useful for debugging. It gives everyone including non-technical teammates the ability to get a better understanding of your data model.","ref":"readme.html#about"},{"type":"extras","title":"Installation and Usage - Dumper","doc":"Add `dumper` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dumper, \"~> 0.1.0\", only: [:dev]}\n  ]\nend\n```\n\nUpdate the dependencies and compile:\n```sh\n$ mix deps.get\n$ mix compile\n```\n\nRun the `dumper.gen` mix task:\n\n```sh\n$ mix dumper.gen\n* creating lib/foo_web/controllers/dumper_controller.ex\n* creating lib/foo_web/controllers/dumper_html.ex\n* creating lib/foo_web/controllers/dumper_html/index.html.heex\n* creating lib/foo_web/controllers/dumper_html/show.html.heex\n* creating lib/foo_web/controllers/dumper_html/home.html.heex\n* creating lib/foo_web/controllers/dumper_html/table_records.html.heex\n* creating lib/foo_web/controllers/dumper_html/pagination.html.heex\n\nAdd the following routes to router:\n\n    get \"/dumper\", DumperController, :home\n    get \"/dumper/*resource\", DumperController, :resource\n\nIt's recommended to put these routes behind some kind of admin plug or environment check\nto avoid potentially leaking access to the public.\n```\n\nLike the output suggests, add the following routes to your router:\n\n``` elixir\nget \"/dumper\", DumperController, :home\nget \"/dumper/*resource\", DumperController, :resource\n```\n\nIt's recommended to put these routes behind some kind of admin plug or environment check to avoid potentially leaking access to the public.  For example:\n\n``` elixir\nscope \"/dumper\" do\n  pipe_through [:browser, :require_admin_user]\n\n  get \"/\", DumperController, :home\n  get \"/*resource\", DumperController, :resource\nend\n```","ref":"readme.html#installation-and-usage"},{"type":"extras","title":"Customization - Dumper","doc":"The Dumper is a mix generator, not a library, so once you run it you are free (and encouraged!) to modify the generated files to suit your needs.\n\nIt is *highly recommended* to add your own `DumperHTML.value/1` function definitions to customize how certain fields, data types, and values are displayed.","ref":"readme.html#customization"},{"type":"extras","title":"Examples - Dumper","doc":"To make all `user_id` column values render a link to that specific user:\n``` elixir\ndefp value(%{field: :user_id} = assigns) do\n  ~H\"\"\"\n   <%= @value %> \n  \"\"\"\nend\n```\n\nBut maybe the `user_id` on the `books` table refers to the author.  Pattern match on the module as well to provide the different implementation:\n``` elixir\ndefp value(%{module: Book, field: :user_id} = assigns) do\n  ~H\"\"\"\n   <%= @value %> \n  \"\"\"\nend\n```\n\nEditing the `controllers/dumper_html.ex` file is a great way to customize the Dumper to your specific application and business logic needs.","ref":"readme.html#examples"},{"type":"extras","title":"Default Behaviour you may want to change - Dumper","doc":"","ref":"readme.html#default-behaviour-you-may-want-to-change"},{"type":"extras","title":"Rendering Embeds - Dumper","doc":"The index page and association tables on the show page by default omit columns that are embeds.  This is purely for display purposes, as those values tend to take up a lot of vertical space.  If you'd like them to be displayed, remove the `:if={field not in embeds(@records)}` on lines `10` and `19` of your generated `dumper_html/table_records.html.heex` file.","ref":"readme.html#rendering-embeds"},{"type":"extras","title":"Redactions - Dumper","doc":"By default, schema fields with `redact: true` are hidden and replaced with the text `redacted`.  If you're running the Dumper in a non-production environment or against dummy data, you may want to disregard the redacted fields.  To do that, you can delete or modify the `defp value(%{redacted: true}) ...` function definition on lines `17-20` of `controllers/dumper_html.ex`.","ref":"readme.html#redactions"},{"type":"extras","title":"Tailwind - Dumper","doc":"The dumper uses tailwind classes to give it some basic styling, since it is included by default with the most recent phoenix generators.  If your project doesn't use tailwind, they won't have an effect, and you are free to delete or replace them once generated.","ref":"readme.html#tailwind"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}